package com.eactive.eai.batch.job.jobItem.cfa;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_CFABT_0210 extends DefaultTelegram implements TelegramService
{

    private int SEND_LENGTH;        //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    private Properties telegramInfo;

    /**
     * 생성자
     */
    public SEND_CFABT_0210() {
        //DATA응답 전문
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {

            boolean result = calculateSendLength();
            if (!result) return false;

            //전송길이
            compileField(0, "" + SEND_LENGTH, this.al_FieldProps[0]);

            //TR - CODE 
        	compileField(1, batchDoc.getBatchMsg().getBody().getRecvFld01(), this.al_FieldProps[1]);

        	//TEXT 개시문자
            compileField(2, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[2]);

            //전문종별코드 - 전문의 기능을 나타내는 4Bytes 코드로 구성
            compileField(3, this.getFldTelegramType(), this.al_FieldProps[3]);

            //업무구분코드
            compileField(4, batchDoc.getBatchMsg().getBody().getRecvFld04(), this.al_FieldProps[4]);
            
            //전문개시일시
            compileField(5, TelegramKeys.getYYYYMMddHHmmss().substring(2), this.al_FieldProps[5]);

            //전문추적번호
            compileField(6, makeZero("", ((byte[]) this.al_Field.get(6)).length), this.al_FieldProps[6]);

            //거래구분코드 - 전문발생기관에서 전문을 구분하기 위하여 부여되는 코드로 한 거래가 끝날때까지 코드가 바뀌지 않고 SET 되어져야 한다.
            //            - 수신기관 CODE(2) : 수신기관에 해당하는 CODE를 기록한다. (기관 CODE CHECK)
            //            - 발신기관 CODE(2) : 발신기관에 해당하는 CODE를 기록한다. (기관 CODE CHECK)
            //            - 발신 단말 번호(8)
            //            - 블록 건수       (6)
            compileField(7, batchDoc.getBatchMsg().getBody().getRecvFld07(), this.al_FieldProps[7]);
            
            //BLOCK 건수 - 데이터 전문 전송 횟수를 set함.
            compileField(8, batchDoc.getBatchMsg().getBody().getRecvFld08(), this.al_FieldProps[8]);
            
            //자료건수 - 한 전문내에 SET할 수 있는 해당 업무별 RECORD의 갯수이며 전문 송신시 실 RECORD의 수를 SET함.
            compileField(9, batchDoc.getBatchMsg().getBody().getRecvFld09(), this.al_FieldProps[9]);
            
            //자료계속 여부 - 향후 사용
            compileField(10, makeZero("", ((byte[]) this.al_Field.get(10)).length), this.al_FieldProps[10]);

            //망 관리정보 - 협회와 신용카드업자간의 시스템 상태에 대한 정보코드로 아래 값 중  하나를 SET 한다
            // 001 - 개시
            // 002 - 재개시
            // 003 - 종료예고
            // 004 - 종료
            // 005 - SYSTEM BUSY
            // 006 - SYSTEM BUSY 회복
            // 007 - SYSTEM 장애
            // 008 - SYSTEM 장애 회복
            // 301 - 상태확인 처리
            compileField(11, this.getFldOpCode(), this.al_FieldProps[11]);
            
            //응답코드 - 전문의 처리결과를 정의해주는 코드로 다음의 응답코드를 기록한다.
            compileField(12, makeZero("", ((byte[]) this.al_Field.get(12)).length), this.al_FieldProps[12]);
            
            // FILLER
            compileField(13, "", this.al_FieldProps[13]);
            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }



    public boolean doPostExecute() {
        try {
            if (!super.doPostExecute()) return false;
			//DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<14; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            batchDoc.getBatchMsg().setTelegramBody("");

            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }


    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);

            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    /**
     * int getCalculatedLength(int idx)
     * --------------------------------------------------------------------------------------
     * 전달된 인덱스 idx는 비정형 필드여야 한다. 즉 필드의 길이값이 FILE_NO_LENGTH("XX") 이어야 한다.
     * 해당 비정형 필드에 대해 실질적인 전문길이를 동적으로 계산해 낸다.
     * RECV : 수신 길이 계산
     */
    public int getCalculatedLength(int idx) {

    	if (idx >= this.getFieldCount()) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI011";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        if (!this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
            String[] msgArgs = new String[2];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            msgArgs[1] = ""+idx;
            String errCode = "BECEAIFJI012";
            String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            return -1;
        }
        return 0;
    }
    public int getInformalFieldSendData(int idx, byte[] data) {
    	int fldLen = getCalculatedLength(idx);
        try {
            if (idx >= this.getFieldCount() ) {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (data.length < fldLen) {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI014";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            return fldLen;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI006";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return -1;
        }
    }


    private boolean calculateSendLength () {
        try {
        	for (int i=1; i< this.al_Field.size(); i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
        	
            REAL_SEND_LENGTH = SEND_LENGTH + ((byte[]) this.al_Field.get(0)).length;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
		return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
		return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
		return super.getFieldValueString(12);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
		return super.getFieldValueString(11);
    }
}

